Imports System.IO
Imports System.Xml.Serialization

' <XmlRoot(Namespace:="http://www.MyNamespace.com")> _
Public Class OrderedItem
    Public Item As String
    Public Price As Decimal
    Private m_Quantity As Integer

    Public Property Quantity() As Integer
        Get
            Quantity = m_Quantity
        End Get
        Set(ByVal Value As Integer)
            m_Quantity = Value
        End Set
    End Property

    Public Sub New()
    End Sub

    Public Sub New(ByVal new_item As String, ByVal new_price As Decimal, ByVal new_quantity As Integer)
        Item = new_item
        Price = new_price
        m_Quantity = new_quantity
    End Sub
End Class

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private m_XMLFile As String

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents txtItem As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents txtPrice As System.Windows.Forms.TextBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents txtQuantity As System.Windows.Forms.TextBox
    Friend WithEvents txtSerialization As System.Windows.Forms.TextBox
    Friend WithEvents btnDeserialize As System.Windows.Forms.Button
    Friend WithEvents btnSerialize As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtPrice = New System.Windows.Forms.TextBox()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.txtQuantity = New System.Windows.Forms.TextBox()
        Me.btnSerialize = New System.Windows.Forms.Button()
        Me.txtSerialization = New System.Windows.Forms.TextBox()
        Me.btnDeserialize = New System.Windows.Forms.Button()
        Me.txtItem = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'txtPrice
        '
        Me.txtPrice.Location = New System.Drawing.Point(56, 32)
        Me.txtPrice.Name = "txtPrice"
        Me.txtPrice.Size = New System.Drawing.Size(64, 20)
        Me.txtPrice.TabIndex = 3
        Me.txtPrice.Text = "0.25"
        Me.txtPrice.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(40, 16)
        Me.Label1.TabIndex = 6
        Me.Label1.Text = "Item"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(8, 32)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(40, 16)
        Me.Label2.TabIndex = 7
        Me.Label2.Text = "Price"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 56)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(48, 16)
        Me.Label3.TabIndex = 8
        Me.Label3.Text = "Quantity"
        '
        'txtQuantity
        '
        Me.txtQuantity.Location = New System.Drawing.Point(56, 56)
        Me.txtQuantity.Name = "txtQuantity"
        Me.txtQuantity.Size = New System.Drawing.Size(64, 20)
        Me.txtQuantity.TabIndex = 4
        Me.txtQuantity.Text = "12"
        Me.txtQuantity.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'btnSerialize
        '
        Me.btnSerialize.Location = New System.Drawing.Point(144, 24)
        Me.btnSerialize.Name = "btnSerialize"
        Me.btnSerialize.Size = New System.Drawing.Size(72, 24)
        Me.btnSerialize.TabIndex = 0
        Me.btnSerialize.Text = "Serialize"
        '
        'txtSerialization
        '
        Me.txtSerialization.BackColor = System.Drawing.SystemColors.Control
        Me.txtSerialization.Location = New System.Drawing.Point(0, 80)
        Me.txtSerialization.Multiline = True
        Me.txtSerialization.Name = "txtSerialization"
        Me.txtSerialization.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtSerialization.Size = New System.Drawing.Size(312, 160)
        Me.txtSerialization.TabIndex = 5
        Me.txtSerialization.Text = ""
        '
        'btnDeserialize
        '
        Me.btnDeserialize.Location = New System.Drawing.Point(240, 24)
        Me.btnDeserialize.Name = "btnDeserialize"
        Me.btnDeserialize.Size = New System.Drawing.Size(72, 24)
        Me.btnDeserialize.TabIndex = 1
        Me.btnDeserialize.Text = "Deserialize"
        '
        'txtItem
        '
        Me.txtItem.Location = New System.Drawing.Point(56, 8)
        Me.txtItem.Name = "txtItem"
        Me.txtItem.Size = New System.Drawing.Size(64, 20)
        Me.txtItem.TabIndex = 2
        Me.txtItem.Text = "Cookies"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(640, 273)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnSerialize, Me.btnDeserialize, Me.txtSerialization, Me.Label3, Me.txtQuantity, Me.Label2, Me.txtPrice, Me.Label1, Me.txtItem})
        Me.Name = "Form1"
        Me.Text = "SerializeOne"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Compose the XML file's name.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_XMLFile = DataSubdirectory() & "\Order.xml"
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim hgt As Integer

        hgt = ClientSize.Height - txtSerialization.Location.Y
        If hgt < 10 Then hgt = 10
        txtSerialization.SetBounds(0, txtSerialization.Location.Y, ClientSize.Width, hgt)
    End Sub

    ' Serialize the data in the TextBoxes.
    Private Sub btnSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        Cursor = Cursors.WaitCursor
        txtSerialization.Text = ""
        Refresh()

        ' Copy the data into an OrderedItem object.
        Dim ordered_item As New OrderedItem( _
            txtItem.Text, _
            CDec(txtPrice.Text), _
            CInt(txtQuantity.Text))

        ' Create an XmlSerializer.
        Dim xml_serializer As New _
            XmlSerializer(GetType(OrderedItem))

        ' Create a FileStream to write with.
        Dim file_stream As New FileStream(m_XMLFile, FileMode.Create)

        ' Serialize the object
        xml_serializer.Serialize(file_stream, ordered_item)

        ' Close the FileStream.
        file_stream.Close()

        ' Display the results.
        txtSerialization.Text = GetFileContents(m_XMLFile)

        ' Clear the TextBoxes.
        txtItem.Text = ""
        txtPrice.Text = ""
        txtQuantity.Text = ""

        Cursor = Cursors.Default
    End Sub

    ' Deserialize the data in the TextBoxes.
    Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
        Cursor = Cursors.WaitCursor
        txtItem.Text = ""
        txtPrice.Text = ""
        txtQuantity.Text = ""
        Refresh()

        ' Create an XmlSerializer.
        Dim xml_serializer As New _
            XmlSerializer(GetType(OrderedItem))

        ' Create a FileStream to read with.
        Dim file_stream As New FileStream(m_XMLFile, FileMode.Open)

        ' Read the item from the serialization.
        Dim ordered_item As OrderedItem
        ordered_item = CType(xml_serializer.Deserialize(file_stream), OrderedItem)
        file_stream.Close()

        ' Copy the data into the TextBoxes.
        With ordered_item
            txtItem.Text = .Item
            txtPrice.Text = .Price
            txtQuantity.Text = .Quantity
        End With

        ' Clear the serialization.
        txtSerialization.Text = ""

        Cursor = Cursors.Default
    End Sub
End Class
