Imports System.IO
Imports System.Xml.Serialization

Public Class Order
    Public Street As String
    Public City As String
    Public State As String
    Public Zip As String
    Public Items() As OrderedItem

    Public Sub New()

    End Sub

    Public Sub New(ByVal new_street As String, ByVal new_city As String, ByVal new_state As String, ByVal new_zip As String)
        Street = new_street
        City = new_city
        State = new_state
        Zip = new_zip
    End Sub
End Class

Public Class OrderedItem
    <XmlAttributeAttribute(AttributeName:="Name")> _
        Public Item As String
    <XmlAttributeAttribute(AttributeName:="Cost")> _
        Public Price As Decimal
    Private m_Quantity As Integer

    <XmlAttributeAttribute(AttributeName:="Number")> _
    Public Property Quantity() As Integer
        Get
            Quantity = m_Quantity
        End Get
        Set(ByVal Value As Integer)
            m_Quantity = Value
        End Set
    End Property

    Public Sub New()
    End Sub

    Public Sub New(ByVal new_item As String, ByVal new_price As Decimal, ByVal new_quantity As Integer)
        Item = new_item
        Price = new_price
        Quantity = new_quantity
    End Sub
End Class

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private m_XMLFile As String

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If Disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(Disposing)
    End Sub
    Friend WithEvents txtSerialization As System.Windows.Forms.TextBox
    Friend WithEvents btnDeserialize As System.Windows.Forms.Button
    Friend WithEvents btnSerialize As System.Windows.Forms.Button
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents Label6 As System.Windows.Forms.Label
        Friend WithEvents Label5 As System.Windows.Forms.Label
                        Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
            Friend WithEvents Label2 As System.Windows.Forms.Label
                                        Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
            Friend WithEvents txtItem0 As System.Windows.Forms.TextBox
            Friend WithEvents txtPrice0 As System.Windows.Forms.TextBox
        Friend WithEvents txtQuantity0 As System.Windows.Forms.TextBox
        Friend WithEvents Label8 As System.Windows.Forms.Label
        Friend WithEvents Label9 As System.Windows.Forms.Label
        Friend WithEvents Label10 As System.Windows.Forms.Label
        Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents txtQuantity2 As System.Windows.Forms.TextBox
    Friend WithEvents txtItem2 As System.Windows.Forms.TextBox
    Friend WithEvents txtItem1 As System.Windows.Forms.TextBox
    Friend WithEvents txtPrice2 As System.Windows.Forms.TextBox
    Friend WithEvents txtPrice1 As System.Windows.Forms.TextBox
    Friend WithEvents txtQuantity1 As System.Windows.Forms.TextBox
    Friend WithEvents txtStreet As System.Windows.Forms.TextBox
    Friend WithEvents txtCity As System.Windows.Forms.TextBox
    Friend WithEvents txtState As System.Windows.Forms.TextBox
    Friend WithEvents txtZip As System.Windows.Forms.TextBox
    
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.Label6 = New System.Windows.Forms.Label()
        Me.Label7 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.txtQuantity1 = New System.Windows.Forms.TextBox()
        Me.txtQuantity0 = New System.Windows.Forms.TextBox()
        Me.txtQuantity2 = New System.Windows.Forms.TextBox()
        Me.Label11 = New System.Windows.Forms.Label()
        Me.GroupBox1 = New System.Windows.Forms.GroupBox()
        Me.txtZip = New System.Windows.Forms.TextBox()
        Me.txtState = New System.Windows.Forms.TextBox()
        Me.Label10 = New System.Windows.Forms.Label()
        Me.txtCity = New System.Windows.Forms.TextBox()
        Me.Label9 = New System.Windows.Forms.Label()
        Me.txtStreet = New System.Windows.Forms.TextBox()
        Me.Label8 = New System.Windows.Forms.Label()
        Me.GroupBox2 = New System.Windows.Forms.GroupBox()
        Me.txtItem2 = New System.Windows.Forms.TextBox()
        Me.txtItem1 = New System.Windows.Forms.TextBox()
        Me.txtItem0 = New System.Windows.Forms.TextBox()
        Me.txtPrice2 = New System.Windows.Forms.TextBox()
        Me.txtPrice1 = New System.Windows.Forms.TextBox()
        Me.txtPrice0 = New System.Windows.Forms.TextBox()
        Me.txtSerialization = New System.Windows.Forms.TextBox()
        Me.btnSerialize = New System.Windows.Forms.Button()
        Me.btnDeserialize = New System.Windows.Forms.Button()
        Me.GroupBox1.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(16, 40)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(40, 16)
        Me.Label4.TabIndex = 12
        Me.Label4.Text = "Price"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(16, 40)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(40, 16)
        Me.Label5.TabIndex = 12
        Me.Label5.Text = "City"
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(16, 64)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(32, 16)
        Me.Label6.TabIndex = 13
        Me.Label6.Text = "State"
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(16, 64)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(48, 16)
        Me.Label7.TabIndex = 13
        Me.Label7.Text = "Quantity"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 40)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(40, 16)
        Me.Label2.TabIndex = 12
        Me.Label2.Text = "Price"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(16, 16)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(40, 16)
        Me.Label3.TabIndex = 11
        Me.Label3.Text = "Item"
        '
        'txtQuantity1
        '
        Me.txtQuantity1.Location = New System.Drawing.Point(136, 64)
        Me.txtQuantity1.Name = "txtQuantity1"
        Me.txtQuantity1.Size = New System.Drawing.Size(64, 20)
        Me.txtQuantity1.TabIndex = 5
        Me.txtQuantity1.Text = "12"
        Me.txtQuantity1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtQuantity0
        '
        Me.txtQuantity0.Location = New System.Drawing.Point(64, 64)
        Me.txtQuantity0.Name = "txtQuantity0"
        Me.txtQuantity0.Size = New System.Drawing.Size(64, 20)
        Me.txtQuantity0.TabIndex = 2
        Me.txtQuantity0.Text = "3"
        Me.txtQuantity0.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtQuantity2
        '
        Me.txtQuantity2.Location = New System.Drawing.Point(208, 64)
        Me.txtQuantity2.Name = "txtQuantity2"
        Me.txtQuantity2.Size = New System.Drawing.Size(64, 20)
        Me.txtQuantity2.TabIndex = 8
        Me.txtQuantity2.Text = "6"
        Me.txtQuantity2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'Label11
        '
        Me.Label11.Location = New System.Drawing.Point(120, 64)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(24, 16)
        Me.Label11.TabIndex = 11
        Me.Label11.Text = "Zip"
        '
        'GroupBox1
        '
        Me.GroupBox1.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtZip, Me.Label11, Me.txtState, Me.Label10, Me.txtCity, Me.Label9, Me.txtStreet, Me.Label8})
        Me.GroupBox1.Location = New System.Drawing.Point(8, 0)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(224, 88)
        Me.GroupBox1.TabIndex = 14
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Address"
        '
        'txtZip
        '
        Me.txtZip.Location = New System.Drawing.Point(144, 64)
        Me.txtZip.Name = "txtZip"
        Me.txtZip.Size = New System.Drawing.Size(72, 20)
        Me.txtZip.TabIndex = 0
        Me.txtZip.Text = "12345-6789"
        '
        'txtState
        '
        Me.txtState.Location = New System.Drawing.Point(56, 64)
        Me.txtState.Name = "txtState"
        Me.txtState.Size = New System.Drawing.Size(24, 20)
        Me.txtState.TabIndex = 0
        Me.txtState.Text = "CA"
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(16, 64)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(40, 16)
        Me.Label10.TabIndex = 11
        Me.Label10.Text = "State"
        '
        'txtCity
        '
        Me.txtCity.Location = New System.Drawing.Point(56, 40)
        Me.txtCity.Name = "txtCity"
        Me.txtCity.Size = New System.Drawing.Size(160, 20)
        Me.txtCity.TabIndex = 0
        Me.txtCity.Text = "Programmerville"
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(16, 40)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(40, 16)
        Me.Label9.TabIndex = 11
        Me.Label9.Text = "City"
        '
        'txtStreet
        '
        Me.txtStreet.Location = New System.Drawing.Point(56, 16)
        Me.txtStreet.Name = "txtStreet"
        Me.txtStreet.Size = New System.Drawing.Size(160, 20)
        Me.txtStreet.TabIndex = 0
        Me.txtStreet.Text = "625 East West St"
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(16, 16)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(40, 16)
        Me.Label8.TabIndex = 11
        Me.Label8.Text = "Street"
        '
        'GroupBox2
        '
        Me.GroupBox2.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtQuantity2, Me.Label3, Me.Label4, Me.Label7, Me.txtItem2, Me.txtItem1, Me.txtItem0, Me.txtPrice2, Me.txtPrice1, Me.txtPrice0, Me.txtQuantity1, Me.txtQuantity0})
        Me.GroupBox2.Location = New System.Drawing.Point(240, 0)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(280, 88)
        Me.GroupBox2.TabIndex = 15
        Me.GroupBox2.TabStop = False
        Me.GroupBox2.Text = "Items"
        '
        'txtItem2
        '
        Me.txtItem2.Location = New System.Drawing.Point(208, 16)
        Me.txtItem2.Name = "txtItem2"
        Me.txtItem2.Size = New System.Drawing.Size(64, 20)
        Me.txtItem2.TabIndex = 6
        Me.txtItem2.Text = "Cupcakes"
        '
        'txtItem1
        '
        Me.txtItem1.Location = New System.Drawing.Point(136, 16)
        Me.txtItem1.Name = "txtItem1"
        Me.txtItem1.Size = New System.Drawing.Size(64, 20)
        Me.txtItem1.TabIndex = 3
        Me.txtItem1.Text = "Cookies"
        '
        'txtItem0
        '
        Me.txtItem0.Location = New System.Drawing.Point(64, 16)
        Me.txtItem0.Name = "txtItem0"
        Me.txtItem0.Size = New System.Drawing.Size(64, 20)
        Me.txtItem0.TabIndex = 0
        Me.txtItem0.Text = "Brownies"
        '
        'txtPrice2
        '
        Me.txtPrice2.Location = New System.Drawing.Point(208, 40)
        Me.txtPrice2.Name = "txtPrice2"
        Me.txtPrice2.Size = New System.Drawing.Size(64, 20)
        Me.txtPrice2.TabIndex = 7
        Me.txtPrice2.Text = ".50"
        Me.txtPrice2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtPrice1
        '
        Me.txtPrice1.Location = New System.Drawing.Point(136, 40)
        Me.txtPrice1.Name = "txtPrice1"
        Me.txtPrice1.Size = New System.Drawing.Size(64, 20)
        Me.txtPrice1.TabIndex = 4
        Me.txtPrice1.Text = "0.25"
        Me.txtPrice1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtPrice0
        '
        Me.txtPrice0.Location = New System.Drawing.Point(64, 40)
        Me.txtPrice0.Name = "txtPrice0"
        Me.txtPrice0.Size = New System.Drawing.Size(64, 20)
        Me.txtPrice0.TabIndex = 1
        Me.txtPrice0.Text = "1.25"
        Me.txtPrice0.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtSerialization
        '
        Me.txtSerialization.BackColor = System.Drawing.SystemColors.Control
        Me.txtSerialization.Location = New System.Drawing.Point(0, 88)
        Me.txtSerialization.Multiline = True
        Me.txtSerialization.Name = "txtSerialization"
        Me.txtSerialization.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtSerialization.Size = New System.Drawing.Size(312, 176)
        Me.txtSerialization.TabIndex = 5
        Me.txtSerialization.TabStop = False
        Me.txtSerialization.Text = ""
        '
        'btnSerialize
        '
        Me.btnSerialize.Location = New System.Drawing.Point(528, 40)
        Me.btnSerialize.Name = "btnSerialize"
        Me.btnSerialize.Size = New System.Drawing.Size(72, 24)
        Me.btnSerialize.TabIndex = 9
        Me.btnSerialize.Text = "Serialize"
        '
        'btnDeserialize
        '
        Me.btnDeserialize.Location = New System.Drawing.Point(608, 40)
        Me.btnDeserialize.Name = "btnDeserialize"
        Me.btnDeserialize.Size = New System.Drawing.Size(72, 24)
        Me.btnDeserialize.TabIndex = 10
        Me.btnDeserialize.Text = "Deserialize"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(688, 269)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.GroupBox2, Me.GroupBox1, Me.btnSerialize, Me.btnDeserialize, Me.txtSerialization})
        Me.Name = "Form1"
        Me.Text = "SerializeSubitem"
        Me.GroupBox1.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Compose the XML file's name.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_XMLFile = DataSubdirectory() & "\Order.xml"
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim hgt As Integer

        hgt = ClientSize.Height - txtSerialization.Location.Y
        If hgt < 10 Then hgt = 10
        txtSerialization.SetBounds(0, txtSerialization.Location.Y, ClientSize.Width, hgt)
    End Sub

    ' Serialize the data in the TextBoxes.
    Private Sub btnSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        Cursor = Cursors.WaitCursor
        txtSerialization.Text = ""
        Refresh()

        ' Make an Order item and load it with the
        ' address infotmation.
        Dim order_info As New Order(txtStreet.Text, txtCity.Text, txtState.Text, txtZip.Text)

        ' Copy the data into OrderedItem objects.
        ReDim order_info.Items(2)
        order_info.Items(0) = New OrderedItem( _
            txtItem0.Text, _
            CDec(txtPrice0.Text), _
            CInt(txtQuantity0.Text))
        order_info.Items(1) = New OrderedItem( _
            txtItem1.Text, _
            CDec(txtPrice1.Text), _
            CInt(txtQuantity1.Text))
        order_info.Items(2) = New OrderedItem( _
            txtItem2.Text, _
            CDec(txtPrice2.Text), _
            CInt(txtQuantity2.Text))

        ' Create an XmlSerializer.
        Dim xml_serializer As New _
            XmlSerializer(GetType(Order))

        ' Create a FileStream to write with.
        Dim file_stream As New FileStream(m_XMLFile, FileMode.Create)

        ' Serialize the array.
        xml_serializer.Serialize(file_stream, order_info)

        ' Close the FileStream.
        file_stream.Close()

        ' Display the results.
        txtSerialization.Text = GetFileContents(m_XMLFile)

        ' Clear the TextBoxes.
        txtStreet.Text = ""
        txtCity.Text = ""
        txtState.Text = ""
        txtZip.Text = ""
        txtItem0.Text = ""
        txtPrice0.Text = ""
        txtQuantity0.Text = ""
        txtItem1.Text = ""
        txtPrice1.Text = ""
        txtQuantity1.Text = ""
        txtItem2.Text = ""
        txtPrice2.Text = ""
        txtQuantity2.Text = ""

        Cursor = Cursors.Default
    End Sub

    ' Deserialize the data in the TextBoxes.
    Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
        Dim ctl As Control
        For Each ctl In Controls
            If (TypeOf ctl Is TextBox) And _
               (Not (ctl Is txtSerialization)) _
            Then
                ctl.Text = ""
            End If
        Next ctl
        Cursor = Cursors.WaitCursor
        Refresh()

        ' Create an XmlSerializer.
        Dim xml_serializer As New _
            XmlSerializer(GetType(Order))

        ' Create an XmlTextReader to read with.
        Dim file_stream As New FileStream(m_XMLFile, FileMode.Open)

        ' Read the item from the serialization.
        Dim order_info As Order
        order_info = CType(xml_serializer.Deserialize(file_stream), Order)
        file_stream.Close()

        ' Copy the data into the TextBoxes.
        With order_info
            txtStreet.Text = .Street
            txtCity.Text = .City
            txtState.Text = .State
            txtZip.Text = .Zip
        End With
        With order_info.Items(0)
            txtItem0.Text = .Item
            txtPrice0.Text = .Price
            txtQuantity0.Text = .Quantity
        End With
        With order_info.Items(1)
            txtItem1.Text = .Item
            txtPrice1.Text = .Price
            txtQuantity1.Text = .Quantity
        End With
        With order_info.Items(2)
            txtItem2.Text = .Item
            txtPrice2.Text = .Price
            txtQuantity2.Text = .Quantity
        End With

        ' Clear the serialization.
        txtSerialization.Text = ""

        Cursor = Cursors.Default
    End Sub
End Class
